package ch.psi.daq.queryrest.response.bson;

import java.io.OutputStream;
import java.util.List;
import java.util.Map.Entry;
import java.util.stream.Stream;

import javax.annotation.Resource;
import javax.servlet.ServletResponse;

import org.apache.commons.lang3.tuple.Triple;

import com.fasterxml.jackson.databind.ObjectMapper;

import ch.psi.daq.domain.json.ChannelName;
import ch.psi.daq.domain.query.DAQQueryElement;
import ch.psi.daq.domain.query.backend.BackendQuery;
import ch.psi.daq.domain.query.response.Response;
import ch.psi.daq.queryrest.response.ResponseStreamWriter;
import ch.psi.daq.queryrest.response.json.JSONResponseStreamWriter;

import de.undercouch.bson4jackson.BsonFactory;

/**
 * Takes a Java 8 stream and writes it to the output stream provided by the {@link ServletResponse}
 * of the current request.
 */
public class BSONResponseStreamWriter implements ResponseStreamWriter {

   @Resource
   private BsonFactory bsonFactory;

   @Resource
   private ObjectMapper mapper;

   @Override
   public void respond(final List<Entry<DAQQueryElement, Stream<Triple<BackendQuery, ChannelName, ?>>>> results,
         final OutputStream out, final Response response) throws Exception {
      JSONResponseStreamWriter.respond(bsonFactory, mapper, results, out, response);
   }
}
